DCMTK: SiBaseRSAProfile Class Reference

DCMTK Version 3.6.9 OFFIS DICOM Toolkit

Loading...
Searching...
No Matches
Public Member Functions | List of all members
SiBaseRSAProfile Class Reference

Base RSA Digital Signature Profile. More...

Inheritance diagram for SiBaseRSAProfile:

## Public Member Functions
| SiBaseRSAProfile ()
| default constructor
virtual | ~SiBaseRSAProfile ()
| destructor
virtual OFBool | isAllowableMACType (E_MACType macType) const
| checks whether the given MAC type can be used with this security profile.
virtual OFBool | isAllowableAlgorithmType (E_KeyType keyType) const
| checks whether the given public/private key algorithm can be used with this security profile.
virtual OFBool | isAllowableTransferSyntax (E_TransferSyntax xfer) const
| checks whether the given transfer syntax can be used with this security profile
virtual OFBool | attributeRequiredIfPresent (const DcmTagKey &key) const
| checks whether an attribute with the given tag is required to be signed for the current security profile if the attribute is present in the dataset
virtual OFBool | checkRequiredAttributeList (DcmAttributeTag &tagList) const
| checks whether all attributes that are required unconditionally to be signed in this profile are included in the given tagList.
virtual OFBool | attributeForbidden (const DcmTagKey &key) const
| checks whether an attribute with the given tag must not be signed for the current security profile.
virtual OFCondition | inspectSignatureDataset (DcmItem &item)
| some digital signature profiles specify conditions under which certain attributes must be included into the signature.
virtual OFBool | mainDatasetRequired () const
| returns true if this signature profile only applies to main dataset level
Public Member Functions inherited from SiSecurityProfile
| SiSecurityProfile ()
| default constructor
virtual | ~SiSecurityProfile ()
| destructor
virtual OFBool | isAllowableMAC (const SiMAC &mac) const
| checks whether the given MAC object can be used with this security profile.
virtual OFBool | isAllowableAlgorithm (const SiAlgorithm &algo) const
| checks whether the given public/private key object can be used with this security profile.
virtual OFCondition | updateAttributeList (DcmItem &item, DcmAttributeTag &tagList)
| updates the given list of attribute tags according to the requirements of the current security profile.
virtual OFCondition | createAttributeList (DcmItem &item, DcmAttributeTag &tagList)
| create a maximum list of attribute tags according to the requirements of the current security profile.
virtual OFBool | checkAttributeList (DcmItem &item, DcmAttributeTag &tagList)
| checks whether the given list of attribute tags fulfils the requirements of the current security profile for the given dataset.
virtual SiSignaturePurpose::E_SignaturePurposeType | getOverrideSignaturePurpose () const
| return the required digital signature purpose for this signature profile

## Additional Inherited Members
Static Public Member Functions inherited from SiSecurityProfile
static OFBool | containsTag (DcmAttributeTag &tagList, const DcmTagKey &key)
| checks if the given tag key is contained in the given list.

## Detailed Description

Base RSA Digital Signature Profile.

Remarks
  This class is only available if DCMTK is compiled with OpenSSL support enabled.

## Member Function Documentation

## ◆ attributeForbidden()

virtual OFBool SiBaseRSAProfile::attributeForbidden | ( | const DcmTagKey & | key | ) | const
| virtual

checks whether an attribute with the given tag must not be signed for the current security profile.

Parameters

  key | tag key to be checked

Returns
  true if attribute must not be signed, false otherwise.

Implements SiSecurityProfile.

## ◆ attributeRequiredIfPresent()

virtual OFBool SiBaseRSAProfile::attributeRequiredIfPresent | ( | const DcmTagKey & | key | ) | const
| virtual

checks whether an attribute with the given tag is required to be signed for the current security profile if the attribute is present in the dataset

Parameters

  key | tag key to be checked

Returns
  true if required, false otherwise.

Implements SiSecurityProfile.

Reimplemented in SiAuthorizationProfile, SiCreatorProfile, SiStructuredReportingProfile, and SiStructuredReportingVerificationProfile.

## ◆ checkRequiredAttributeList()

virtual OFBool SiBaseRSAProfile::checkRequiredAttributeList | ( | DcmAttributeTag & | tagList | ) | const
| virtual

checks whether all attributes that are required unconditionally to be signed in this profile are included in the given tagList.

Parameters

  taglist | attribute tag list

Returns
  true if requirements for profile are fulfilled, false otherwise.

Implements SiSecurityProfile.

Reimplemented in SiAuthorizationProfile, SiCreatorProfile, SiStructuredReportingProfile, and SiStructuredReportingVerificationProfile.

## ◆ inspectSignatureDataset()

virtual OFCondition SiBaseRSAProfile::inspectSignatureDataset | ( | DcmItem & | item | ) |
| virtual

some digital signature profiles specify conditions under which certain attributes must be included into the signature.

This method allows the signature profile to inspect the dataset in order to determine whether or not the conditions are met. This method should be called before DcmSignature::createSignature() is executed.

Parameters

  item | the dataset or item to which the signature will be added

Returns
  status code

Implements SiSecurityProfile.

Reimplemented in SiAuthorizationProfile, SiCreatorProfile, SiStructuredReportingProfile, and SiStructuredReportingVerificationProfile.

## ◆ isAllowableAlgorithmType()

virtual OFBool SiBaseRSAProfile::isAllowableAlgorithmType | ( | E_KeyType | keyType | ) | const
| virtual

checks whether the given public/private key algorithm can be used with this security profile.

Parameters

  keyType | public key algorithm type to be checked

Returns
  true if public key algorithm is allowable for this profile, false otherwise.

Implements SiSecurityProfile.

## ◆ isAllowableMACType()

virtual OFBool SiBaseRSAProfile::isAllowableMACType | ( | E_MACType | macType | ) | const
| virtual

checks whether the given MAC type can be used with this security profile.

Parameters

  macType | MAC type to be checked

Returns
  true if MAC type is allowable for this profile, false otherwise.

Implements SiSecurityProfile.

## ◆ isAllowableTransferSyntax()

virtual OFBool SiBaseRSAProfile::isAllowableTransferSyntax | ( | E_TransferSyntax | xfer | ) | const
| virtual

checks whether the given transfer syntax can be used with this security profile

Parameters

  xfer | transfer syntax to be checked

Returns
  true if transfer syntax is allowable for this profile, false otherwise.

Implements SiSecurityProfile.

## ◆ mainDatasetRequired()

virtual OFBool SiBaseRSAProfile::mainDatasetRequired | ( |  | ) | const
| virtual

returns true if this signature profile only applies to main dataset level

Returns
  OFTrue if this signature profile only applies to main dataset level, OFFalse otherwise

Implements SiSecurityProfile.

Reimplemented in SiAuthorizationProfile, SiCreatorProfile, and SiStructuredReportingProfile.

The documentation for this class was generated from the following file:

- dcmsign/include/dcmtk/dcmsign/sibrsapr.h

Generated on Sat Mar 1 2025 for DCMTK Version 3.6.9 by Doxygen 1.13.2